#
# wakaba/error.rb
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: error.rb,v 1.1 2002/09/10 11:07:27 katsu Exp $
#


module Wakaba

  class AbstractMethod < NotImplementedError
    def initialize
      super 'abstract method'
    end
  end

  class Error < StandardError ; end

  class AccessError < Error ;end
  class InvalidSessionIndex < AccessError ; end
  class IncompatibleSession < AccessError ; end
  class ExpiredSession < AccessError ; end
  class AccessDenied < AccessError ; end
  class ActionNotFound < AccessError ; end
  class SessionNotFound < AccessError ; end

  class StoreError < Error ; end
  class LockFailed < StoreError ; end
  class LockUnsupported < LockFailed ; end

  class SessionError < Error ; end
  class SessionNameError < SessionError ; end
  class SessionTypeError < SessionError ; end
  class ActionNameError < SessionError ; end

end
