#
# wakaba/interface.rb
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: interface.rb,v 1.1 2002/09/10 11:07:27 katsu Exp $
#

require 'wakaba/error'


module Wakaba

  class Interface

    def initialize
      @starttime = Time.now
    end

    attr_reader :starttime


    def start
      # do nothing by default
    end

    def index
      raise AbstractMethod
    end

    def client_key
      raise AbstractMethod
    end

    def session_name
      raise AbstractMethod
    end

    def action
      raise AbstractMethod
    end

    def out(context, index, client_key)
      raise AbstractMethod
    end

    def access_error(error)
      raise AbstractMethod
    end


    # interface for Context

    def cgienv(key)
      raise AbstractMethod
    end

    def header_in(key)
      raise AbstractMethod
    end

    def param
      raise AbstractMethod
    end

    def href(session_name, action)
      raise AbstractMethod
    end

    def base_uri
      raise AbstractMethod
    end

  end

end
