#
# pbinding.rb - protected binding & eval
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: pbinding.rb,v 1.1 2002/07/29 10:49:55 katsu Exp $
#

module Wakaba

  class ProtectedBinding

    def __eval__(src, parameters = nil, *args)
      klass = class << self
        undef_method :__eval__
        self
      end
      klass.module_eval "def wakaba_binding; binding; end"
      b = wakaba_binding
      if parameters and not parameters.empty? then
        carrier = 'VARIABLE'
        carrier << '_' while parameters.key? carrier
        carrier = carrier.intern
        klass.module_eval { const_set carrier, parameters }
        eval parameters.keys.collect{|k|"#{k}=#{carrier}[#{k.dump}];"}.join, b
        klass.module_eval { remove_const carrier }
      end
      klass.module_eval {
        remove_method :wakaba_binding
        const_set :TOPLEVEL_BINDING, b
      }
      eval(src, b, *args)
    end

  end



  class ProtectedEval

    def initialize
      @parameters = {}
    end

    def []=(key, value)
      key = key.id2name if Symbol === key
      unless /\A[a-z_]\w*\z/n =~ key then
        raise ArgumentError, "illigal parameter name"
      end
      @parameters[key] = value
    end

    def new_binding
      ProtectedBinding.new
    end
    private :new_binding

    def eval(src, *args)
      new_binding.__eval__(src, @parameters, *args)
    end

  end

end
