#!/usr/bin/ruby
#
# hello.rb - a simple example for Wakaba
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: hello.rb,v 1.3 2002/09/10 11:27:22 katsu Exp $
#

require 'wakaba/wakaba'
require 'wakaba/interface/cgi'


class HelloWorld < Wakaba::Session

  def initialize
    @times = 0
  end

  def setup(context)
    context.header_out['Content-Type'] = 'text/html; charset=iso-8859-1'
  end
  private :setup

  def welcome(context)
    @times += 1
    if @times >= 10 then
      context.finale
    end
    context.puts %'<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN">'
    context.puts %'<html><head><title>Hello, World!</title></head>'
    context.puts %'<body><p>'
    context.puts %'<a href="#{context.href(self, :welcome)}">Hello, World!</a>'
    context.puts %' (#{@times} times)'
    context.puts %'</p></body></html>'
  end

end


c = Wakaba::Controller.new
c.interface = Wakaba::CGIInterface.new
c.store = Wakaba::EchoStore.new('version 1', 60)        # 1 min.
c.identifier = Wakaba::SimpleIdentifier.new('secret')
c.start { HelloWorld.new }
