#!/usr/bin/ruby
#
# runtest.rb
#
# $Id: runtest.rb,v 1.5 2002/07/29 10:50:59 katsu Exp $
#

require 'runit/testcase'
require 'runit/testsuite'
require 'runit/cui/testrunner'

if ARGV[0] == '-v' then
  ARGV.shift
else
  RUNIT::CUI::TestRunner.quiet_mode = true
end

suite = RUNIT::TestSuite.new
ObjectSpace.each_object(Class) { |c|
  if /\ATest/ =~ c.name and c.ancestors.include? RUNIT::TestCase then
    if ARGV.empty? or ARGV.include? c.name then
      suite.add c.suite
    end
  end
}

module RUNIT
  class TestFailure
    alias __orig_at at
    remove_method :at
    def at
      a = __orig_at.dup
      re = /\A#{__FILE__}:\d+\z/
      a.size.times {
        break if re =~ a.last
        a.pop
      }
      a
    end
  end
end

$SAFE = 1
RUNIT::CUI::TestRunner.run suite
