#
# testinterface.rb - test cases for Wakaba
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: testinterface.rb,v 1.1 2002/09/10 11:07:27 katsu Exp $
#

require 'runit/testcase'
require 'asserttracecall'
require 'wakaba/interface'


class TestInterface < RUNIT::TestCase

  def setup
    @i = Wakaba::Interface.new
  end

  def test_starttime
    assert_kind_of Time, @i.starttime
  end

  def test_start
    assert_no_exception { @i.start }
  end


  def test_index
    assert_exception(Wakaba::AbstractMethod) { @i.index }
  end

  def test_client_key
    assert_exception(Wakaba::AbstractMethod) { @i.client_key }
  end

  def test_session_name
    assert_exception(Wakaba::AbstractMethod) { @i.session_name }
  end

  def test_action
    assert_exception(Wakaba::AbstractMethod) { @i.action }
  end

  def test_out
    #assert_exception(Wakaba::AbstractMethod) { @i.out }
  end

  def test_access_error
    #assert_exception(Wakaba::AbstractMethod) { @i.access_error }
  end

  def test_cgienv
    assert_exception(Wakaba::AbstractMethod) { @i.cgienv('HOGE') }
  end

  def test_header_in
    assert_exception(Wakaba::AbstractMethod) { @i.header_in('Hoge') }
  end

  def test_param
    assert_exception(Wakaba::AbstractMethod) { @i.param }
  end

  def test_href
    assert_exception(Wakaba::AbstractMethod) { @i.href('hoge', 'fuga') }
  end

  def test_base_uri
    assert_exception(Wakaba::AbstractMethod) { @i.base_uri }
  end

end





load "#{File.dirname($0)}/runtest.rb" if __FILE__ == $0
