#
# teststrio.rb - test cases for Wakaba
#
#   Copyright (C) UENO Katsuhiro 2002
#
# $Id: teststrio.rb,v 1.1 2002/07/15 01:59:47 katsu Exp $
#

require 'runit/testcase'
require 'wakaba/strio'


class TestStringIO < RUNIT::TestCase

  def setup
    @s = Wakaba::StringIO.new('hoge')
  end

  def test_s_new
    @s = Wakaba::StringIO.new
    assert_equal '', @s.string
  end

  def test_s_new_same
    s = 'fuga'
    sio = Wakaba::StringIO.new(s)
    assert_same s, sio.string
  end

  def test_string
    assert_equal 'hoge', @s.string
  end

  def test_string_eq
    @s.string = s = 'fuga'
    assert_same s, @s.string
  end

  def test_write
    assert_equal 4, @s.write('fuga')
    assert_equal 'hogefuga', @s.string
  end

  def test_addstr
    assert_same(@s, @s << 'fuga')
    assert_equal 'hogefuga', @s.string
  end

  def test_print
    @s.print 'fuga'
    assert_equal 'hogefuga', @s.string
  end

  def test_printf
    @s.printf 'fu%sga', 'foobar'
    assert_equal 'hogefufoobarga', @s.string
  end

  def test_puts
    @s.puts 'fuga'
    assert_equal "hogefuga\n", @s.string
  end

  def test_putc
    @s.putc ?f
    assert_equal 'hogef', @s.string
    @s.putc "f"
    assert_equal 'hogeff', @s.string
    @s.putc "uga"
    assert_equal 'hogeffu', @s.string
  end

end





load "#{File.dirname($0)}/runtest.rb" if __FILE__ == $0
